'use strict';

exports.__esModule = true;
exports.default = createInjectParamTypes;
function createInjectParamTypes(t, reflectId, typeForAnnotations, paramKey, typeKey, functionsWithJsx) {
    var metaDataId = t.memberExpression(reflectId || t.identifier('Reflect'), t.identifier('defineMetadata'));
    // console.log(functionsWithJsx)
    return function injectParamTypes(rawTypes, target, node) {
        var body = [];
        var type = node.type;
        var isJsx = functionsWithJsx.has(node);

        if (rawTypes.length) {
            var types = void 0;
            if (isJsx) {
                types = rawTypes.length > 1 ? [rawTypes[1]] : [];
            } else {
                types = rawTypes;
            }
            var typeArgs = typeForAnnotations(types, node.typeParameters ? node.typeParameters.params : null);
            if (typeArgs.length) {
                body.push(t.expressionStatement(t.callExpression(metaDataId, [t.stringLiteral(paramKey), t.arrayExpression(typeArgs), target])));
            }

            for (var i = 0; i < types.length; i++) {
                var argType = types[i];
                var decorators = argType.decorators || [];
                for (var j = 0; j < decorators.length; j++) {
                    body.push(t.expressionStatement(t.callExpression(decorators[j].expression, [target, t.identifier('null'), t.identifier(i.toString())])));
                }
            }
        }

        if (type === 'FunctionDeclaration' || type === 'FunctionExpression' || type === 'ArrowFunctionExpression') {
            body.push(t.expressionStatement(t.callExpression(metaDataId, [t.stringLiteral(typeKey), t.stringLiteral(isJsx ? 'jsx' : 'func'), target])));
        }

        return body;
    };
}
//# sourceMappingURL=createInjectParamTypes.js.map